#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <poll.h>


int main(void) {

  int fd;
  struct pollfd p_fd;
  char c;

  puts("Shutdown by rising edge on gpio6");

  //Enable gpio6
  fd = open("/sys/class/gpio/export", O_WRONLY);
  if (fd == -1) {
    fprintf(stderr, "Error: can't enable to access gpio6\n");
    return 1;
  }
  write(fd, "6", 1);
  close(fd);

  //Set gpio6 as input
  fd = open("/sys/class/gpio/gpio6/direction", O_WRONLY);
  if (fd == -1) {
    fprintf(stderr, "Error: can't set direction on gpio6\n");
    return 1;
  }
  write(fd, "in", 2);
  close(fd);

  //Set interrupt on rising edge on gpio6 
  fd = open("/sys/class/gpio/gpio6/edge", O_WRONLY);
  if (fd == -1) {
    fprintf(stderr, "Error: can't set interrupt on rising edge on gpio6\n");
    return 1;
  }
  write(fd, "rising", 7);
  close(fd);

  fd = open("/sys/class/gpio/gpio6/value", O_RDONLY);
  if (fd == -1) {
    fprintf(stderr, "Error: can't read value on gpio6\n");
    return 1;
  }
  else {
    p_fd.fd = fd;
    p_fd.events = POLLPRI;

    read(fd, &c, 1);
    lseek(fd, 0, SEEK_SET);
    poll(&p_fd, 1, -1);
  }
  close(fd);

  puts("Rising edge on gpio6 detected");
  system("sudo shutdown -h now");

  return 0;
}

